'use strict';const classNames=require('classnames'),PropTypes=require('prop-types'),React=require('react'),AccordionSection=require('../accordion-section/accordion-section'),cookieUtil=require('../../init/cookie-util'),DeploymentBudget=require('./budget/budget'),DeploymentCloud=require('./cloud/cloud'),DeploymentCredential=require('./credential/credential'),DeploymentDirectDeploy=require('./direct-deploy/direct-deploy'),DeploymentExpertBudget=require('./expert-budget/expert-budget'),DeploymentExpertIntro=require('./expert-intro/expert-intro'),DeploymentLogin=require('./login/login'),DeploymentMachines=require('./machines/machines'),DeploymentModelName=require('./model-name/model-name'),DeploymentPanel=require('./panel/panel'),DeploymentPayment=require('./payment/payment'),DeploymentPricing=require('./pricing/pricing'),DeploymentSection=require('./section/section'),DeploymentServices=require('./services/services'),DeploymentSSHKey=require('./sshkey/sshkey'),DeploymentVPC=require('./vpc/vpc'),Spinner=require('../spinner/spinner'),GenericButton=require('../generic-button/generic-button'),INITIAL_VPC_ID=null;class DeploymentFlow extends React.Component{constructor(a){super(a),this.xhrs=[];const b=this.props.modelCommitted;this.state={budget:null,cloud:b?this.props.cloud:null,cloudCount:0,credential:this.props.credential,deploying:!1,ddEntity:null,loadingEntity:!1,loadingTerms:!1,isDirectDeploy:!!(this.props.ddData&&this.props.ddData.id),newTerms:[],paymentUser:null,region:this.props.region,sshKeys:[],lpUsernames:[],terms:this._getTerms()||[],termsAgreed:!1,vpcId:INITIAL_VPC_ID,vpcIdForce:!1}}componentWillMount(){this.props.isLoggedIn()&&this._getAgreements(),this.sendAnalytics('Component mounted'),this.state.isDirectDeploy&&this._getDirectDeployEntity(this.props.ddData.id)}componentWillReceiveProps(a){const b=a.applications,c=this.props.applications,d=b.filter((b)=>-1===c.indexOf(b));(b.length!==c.length||0<d.length)&&this._getAgreements()}componentWillUnmount(){this.xhrs.forEach((a)=>{a&&a.abort&&a.abort()})}_getDirectDeployEntity(a){const b=this.props;this.setState({loadingEntity:!0}),b.getEntity(a,(a,c)=>{return this.setState({loadingEntity:!1}),a?(console.error('unable to fetch entity: '+a),void b.addNotification({title:'Unable to fetch entity',message:`Unable to fetch entity: ${a}`,level:'error'})):void this.setState({ddEntity:this.props.makeEntityModel(c[0])})})}_getSectionStatus(a){let b,c,d;const e=!!this.state.cloud,f=!!this.state.sshKeys.length,g=!!this.state.credential,h=!this.props.modelCommitted,i=this.props.groupedChanges,j=this.props.isLoggedIn(),k=this.state.ddEntity&&this.state.ddEntity.get('supported'),l=!!this.state.budget;switch(a){case'model-name':b=!!this.props.modelName,c=!1,d=j&&h;break;case'cloud':b=e&&g,c=!j,d=j&&(h||!b)&&(!k||k&&l);break;case'credential':b=!1,c=!e,d=j&&h&&e&&(!k||k&&l);break;case'ssh-key':b=f,c=!e,d=j&&h&&!k;break;case'vpc':b=!1,c=!e,d=j&&h&&e&&g&&'aws'===this.state.cloud.name&&!k;break;case'machines':const m=i._addMachines;b=!1,c=!e||!g,d=j&&m&&0<Object.keys(m).length&&!k;break;case'services':b=!1,c=!e||!g,d=j&&!k;break;case'budget':b=!1,c=!e||!g,d=j&&this.props.withPlans&&!k;break;case'payment':b=!!this.state.paymentUser,c=!1,d=j&&this.props.showPay&&(!k||k&&l);break;case'agreements':const n=this.state.newTerms;b=!1,c=!e||!g,d=j&&n&&0<n.length&&(!k||k&&l);break;case'deploy':b=!1,c=!1,d=j&&(!k||k&&l);break;case'pricing':b=!1,c=!1,d=j&&k;break;case'expert-budget':b=!1,c=!1,d=j&&k;}return{completed:b,disabled:c,visible:d}}_setCloud(a){this.setState({cloud:a,vpcId:INITIAL_VPC_ID})}_setCloudCount(a){this.setState({cloudCount:a})}_setCredential(a){this.setState({credential:a})}_setRegion(a){this.setState({region:a})}_setSSHKeys(a){this.setState({sshKeys:a})}_setLaunchpadUsernames(a){this.setState({lpUsernames:a})}_setVPCId(a,b){a||(a=INITIAL_VPC_ID,b=!1),this.setState({vpcId:a,vpcIdForce:!!b})}_setBudget(a){this.setState({budget:a})}_setPaymentUser(a){this.setState({paymentUser:a})}_deployCallback(a){return a?void this.setState({deploying:!1}):void this.props.changeState({gui:{deploy:null}})}_clearCloud(){this._setCloud(null),this._setCredential(null)}_handleDeploy(){if(!this._deploymentAllowed())return void console.error('deploy button clicked but it should have been disabled');this.setState({deploying:!0}),this.sendAnalytics('Button click','Deploy model'),this.props.stats&&this.props.stats.increase('deploy');const a={config:{},cloud:this.state.cloud&&this.state.cloud.name||void 0,credential:this.state.credential,region:this.state.region};if(this.state.sshKeys.length){const b=this.state.sshKeys.slice();a.config['authorized-keys']=b.shift().text;this.props.addSSHKeys(this.props.getUserName(),b.map((a)=>a.text),(a)=>{a&&this.props.addNotification({title:'Cannot add SSH keys',message:`Cannot add SSH keys: ${a}`,level:'error'})},{})}this.state.lpUsernames.length&&this.props.importSSHKeys(this.props.getUserName(),this.state.lpUsernames.map((a)=>`lp:${a}`),(a)=>{a&&this.props.addNotification({title:'Cannot import SSH keys',message:`Cannot import SSH keys: ${a}`,level:'error'})}),this.state.vpcId&&(a.config['vpc-id']=this.state.vpcId,a.config['vpc-id-force']=this.state.vpcIdForce);const b=this.props.deploy.bind(this,this._deployCallback.bind(this),!0,this.props.modelName,a);if(0<this.state.newTerms.length){const a=this.state.newTerms.map((a)=>{const b={name:a.name,revision:a.revision};return a.owner&&(b.owner=a.owner),b});this.props.addAgreement(a,(a)=>{return a?void this.props.addNotification({title:'Could not agree to terms',message:`Could not agree to terms: ${a}`,level:'error'}):void b()})}else b()}_getTerms(){const a=[],b=this.props.groupedChanges._deploy;if(!b)return;Object.keys(b).forEach((c)=>{a.push(b[c].command.args[0].charmURL)})||[];const c=[];return a.forEach((a)=>{const b=this.props.charmsGetById(a).get('terms');b&&0<b.length&&b.forEach((a)=>{-1===c.indexOf(a)&&c.push(a)})}),c}_getAgreements(){const a=this.state.terms;return 0===a.length?void this.setState({newTerms:[],loadingTerms:!1}):void this.setState({loadingTerms:!0},()=>{const b=this.props.getAgreementsByTerms(a,(a,b)=>{return a?(this.props.addNotification({title:'Problem loading terms',message:`Problem loading terms: ${a}`,level:'error'}),void console.error('Problem loading terms:',a)):void this.setState({newTerms:b||[],loadingTerms:!1})});this.xhrs.push(b)})}_parseTermId(a){const b=a.split('/');let c=null,d=null,e=null;return 3===b.length?(c=b[0],d=b[1],e=parseInt(b[2])):1===b.length?d=b[0]:isNaN(b[1])?(c=b[0],d=b[1]):(d=b[0],e=parseInt(b[1])),{owner:c,name:d,revision:e}}_generateCloudAction(){return 1>=this.state.cloudCount||!this.state.cloud||this.props.modelCommitted?void 0:[{action:this._clearCloud.bind(this),disabled:this.props.acl.isReadOnly(),title:'Change cloud',type:'neutral'}]}_generateSSHKeySection(){const a=this._getSectionStatus('ssh-key');if(!a.visible)return;const b=this.state.cloud,c=b&&'azure'===b.cloudType;let d=React.createElement('span',null,'Add public SSH keys ',React.createElement('em',null,'(optional)'));return c&&(d=React.createElement('span',null,'Add public SSH keys')),React.createElement(DeploymentSection,{completed:a.completed,disabled:a.disabled,instance:'deployment-ssh-key',showCheck:!0,title:d},React.createElement(DeploymentSSHKey,{addNotification:this.props.addNotification,cloud:b,getGithubSSHKeys:this.props.getGithubSSHKeys,setLaunchpadUsernames:this._setLaunchpadUsernames.bind(this),setSSHKeys:this._setSSHKeys.bind(this),username:this.props.username,WebHandler:this.props.WebHandler}))}_generateVPCSection(){const a=this._getSectionStatus('vpc');return a.visible?React.createElement('div',{className:'deployment-vpc'},React.createElement(AccordionSection,{title:React.createElement('span',null,'Add AWS VPC ID ',React.createElement('em',null,'(optional)'))},React.createElement(DeploymentVPC,{setVPCId:this._setVPCId.bind(this)}))):void 0}_generateModelNameSection(){const a=this._getSectionStatus('model-name');return a.visible?React.createElement(DeploymentSection,{completed:a.completed,instance:'deployment-model-name',showCheck:!0,title:'Set your model name'},React.createElement(DeploymentModelName,{acl:this.props.acl,ddEntity:this.state.ddEntity,modelName:this.props.modelName,setModelName:this.props.setModelName})):void 0}_generatePricingSection(){const a=this._getSectionStatus('pricing');return a.visible?React.createElement(DeploymentSection,{completed:a.completed,instance:'deployment-pricing',showCheck:!0,title:'Pricing'},React.createElement(DeploymentPricing,{addNotification:this.props.addNotification,applications:this.props.applications,charms:this.props.charms,getSLAMachineRates:this.props.getSLAMachineRates,listPlansForCharm:this.props.listPlansForCharm})):void 0}_generateExpertBudgetSection(){const a=this._getSectionStatus('expert-budget');return a.visible?React.createElement(DeploymentSection,{completed:a.completed,instance:'deployment-expert-budget',showCheck:!0,title:'Set your maximum monthly budget (optional)'},React.createElement(DeploymentExpertBudget,null)):void 0}sendAnalytics(a,...b){this.props.ddData?b.push('is DD'):b.push('is from canvas'),this.props.modelCommitted?b.push('is model update'):b.push('is new model'),this.props.gisf?b.push('has USSO'):b.push('doesn\'t have USSO'),this.props.sendAnalytics('Deployment Flow',a,b.join(' - '))}_shouldShowLoginLinks(){const a=this.state,b=a.isDirectDeploy;return!b||a.isDirectDeploy&&!a.loadingEntity&&!!a.ddEntity}_generateLogin(){const a=this.state;if(this.props.isLoggedIn())return null;return React.createElement(DeploymentLogin,{addNotification:this.props.addNotification,callback:(a)=>{a||this._getAgreements()},gisf:this.props.gisf,isDirectDeploy:a.isDirectDeploy,loginToController:this.props.loginToController,showLoginLinks:this._shouldShowLoginLinks()})}_generateCloudSection(){var a=this._getSectionStatus('cloud');if(a.visible){var b=this.state.cloud;return React.createElement(DeploymentSection,{buttons:this._generateCloudAction(),completed:a.completed,disabled:a.disabled,instance:'deployment-cloud',showCheck:!0,title:'Choose cloud to deploy to'},React.createElement(DeploymentCloud,{acl:this.props.acl,addNotification:this.props.addNotification,cloud:b,controllerIsReady:this.props.controllerIsReady,getCloudProviderDetails:this.props.getCloudProviderDetails,listClouds:this.props.listClouds,setCloud:this._setCloud.bind(this),setCloudCount:this._setCloudCount.bind(this)}))}}_generateCredentialSection(){var a=this._getSectionStatus('credential');if(a.visible){var b=this.state.cloud;return React.createElement(DeploymentSection,{completed:a.completed,disabled:a.disabled,instance:'deployment-credential',showCheck:!1},React.createElement(DeploymentCredential,{acl:this.props.acl,addNotification:this.props.addNotification,cloud:b,controllerIsReady:this.props.controllerIsReady,credential:this.state.credential,editable:!this.props.modelCommitted,generateCloudCredentialName:this.props.generateCloudCredentialName,getCloudCredentialNames:this.props.getCloudCredentialNames,getCloudCredentials:this.props.getCloudCredentials,getCloudProviderDetails:this.props.getCloudProviderDetails,region:this.state.region,sendAnalytics:this.sendAnalytics.bind(this),setCredential:this._setCredential.bind(this),setRegion:this._setRegion.bind(this),updateCloudCredential:this.props.updateCloudCredential,user:this.props.getUserName(),validateForm:this.props.validateForm}),this._generateVPCSection())}}_generateMachinesSection(){var a=this._getSectionStatus('machines');if(a.visible){var b=this.state.cloud;return React.createElement(DeploymentSection,{completed:a.completed,disabled:a.disabled,instance:'deployment-machines',showCheck:!1,title:'Machines to be provisioned'},React.createElement(DeploymentMachines,{acl:this.props.acl,cloud:b,formatConstraints:this.props.formatConstraints,generateMachineDetails:this.props.generateMachineDetails,machines:this.props.groupedChanges._addMachines}))}}_generateServicesSection(){var a=this._getSectionStatus('services');return a.visible?React.createElement('div',{className:'deployment-services'},React.createElement(AccordionSection,{startOpen:this.props.modelCommitted,title:'Model changes'},React.createElement(DeploymentServices,{acl:this.props.acl,addNotification:this.props.addNotification,changesFilterByParent:this.props.changesFilterByParent,charmsGetById:this.props.charmsGetById,generateAllChangeDescriptions:this.props.generateAllChangeDescriptions,generateChangeDescription:this.props.generateChangeDescription,getCurrentChangeSet:this.props.getCurrentChangeSet,getServiceByName:this.props.getServiceByName,listPlansForCharm:this.props.listPlansForCharm,parseTermId:this._parseTermId.bind(this),showTerms:this.props.showTerms,sortDescriptionsByApplication:this.props.sortDescriptionsByApplication,withPlans:this.props.withPlans}))):void 0}_generateBudgetSection(){var a=this._getSectionStatus('budget');return a.visible?React.createElement(DeploymentSection,{completed:a.completed,disabled:a.disabled,instance:'deployment-budget',showCheck:!0,title:'Confirm budget'},React.createElement(DeploymentBudget,{acl:this.props.acl,addNotification:this.props.addNotification,listBudgets:this.props.listBudgets,setBudget:this._setBudget.bind(this),user:this.props.getUserName()})):void 0}_generatePaymentSection(){const a=this._getSectionStatus('payment');return this.props.showPay&&a.visible?React.createElement(DeploymentSection,{completed:a.completed,disabled:a.disabled,instance:'deployment-payment',showCheck:!0,title:'Payment details'},React.createElement(DeploymentPayment,{acl:this.props.acl,addNotification:this.props.addNotification,createCardElement:this.props.createCardElement,createToken:this.props.createToken,createUser:this.props.createUser,getCountries:this.props.getCountries,getUser:this.props.getUser,paymentUser:this.state.paymentUser,setPaymentUser:this._setPaymentUser.bind(this),username:this.props.profileUsername,validateForm:this.props.validateForm})):null}_handleTermsAgreement(a){this.setState({termsAgreed:a.target.checked})}_generateAgreementsSection(){const a=this._getSectionStatus('agreements');if(a.visible){const b=this.props.acl.isReadOnly()||a.disabled,c=classNames('deployment-flow__agreements','deployment-flow__deploy-option',{"deployment-flow__deploy-option--disabled":a.disabled});return React.createElement('div',{className:c},React.createElement('input',{className:'deployment-flow__deploy-checkbox',disabled:b,id:'terms',onChange:this._handleTermsAgreement.bind(this),type:'checkbox'}),React.createElement('label',{className:'deployment-flow__deploy-label',htmlFor:'terms'},'I agree to all terms.'))}}_generateDeploySection(){const a=this._getSectionStatus('deploy');if(!a.visible)return;const b=this.state.deploying;let c=this.props.modelCommitted?b?'Committing...':'Commit':b?'Deploying...':'Deploy';const d=classNames('inner-wrapper','deployment-flow__deploy',{"deployment-flow__deploy--cookie-visible":this.props.gtmEnabled&&cookieUtil.shouldShowNotification(document)});return React.createElement('div',{className:'twelve-col'},React.createElement('div',{className:d},this._generateAgreementsSection(),React.createElement('div',{className:'deployment-flow__deploy-action'},React.createElement(GenericButton,{action:this._handleDeploy.bind(this),disabled:!this._deploymentAllowed(),type:'positive'},c))))}_generateExpertIntro(){return React.createElement(DeploymentExpertIntro,{addNotification:this.props.addNotification,changeState:this.props.changeState,ddData:this.props.ddData,entityModel:this.state.ddEntity,generatePath:this.props.generatePath,getDiagramURL:this.props.getDiagramURL,renderMarkdown:this.props.renderMarkdown,sendAnalytics:this.props.sendAnalytics,staticURL:this.props.staticURL})}_generateDirectDeploy(){const a=this.props,b=this.state;return this.state.isDirectDeploy?b.loadingEntity?React.createElement(Spinner,null):b.loadingEntity?null:b.ddEntity&&b.ddEntity.get('supported')?this._generateExpertIntro():React.createElement(DeploymentDirectDeploy,{addNotification:a.addNotification,changeState:a.changeState,ddData:a.ddData,entityModel:b.ddEntity,generatePath:a.generatePath,getDiagramURL:a.getDiagramURL,renderMarkdown:a.renderMarkdown}):void 0}_deploymentAllowed(){if(!this.props.modelName)return!1;if(!this.state.cloud)return!1;if(!this.state.credential)return!1;if(this.props.acl.isReadOnly()||this.state.deploying)return!1;const a=this.state.newTerms;return a&&0<a.length&&!this.state.termsAgreed?!1:!this.state.loadingTerms&&(this.props.showPay&&!this.state.paymentUser?!1:!!this.props.modelCommitted||'azure'!==this.state.cloud.cloudType||this.state.sshKeys)}render(){return React.createElement('div',{className:'deployment-flow'},React.createElement(DeploymentPanel,{changeState:this.props.changeState,isDirectDeploy:this.state.isDirectDeploy,loggedIn:this.props.isLoggedIn(),sendAnalytics:this.sendAnalytics.bind(this),title:this.props.modelName},this._generateDirectDeploy(),this._generateModelNameSection(),this._generatePricingSection(),this._generateExpertBudgetSection(),this._generateCloudSection(),this._generateCredentialSection(),this._generateSSHKeySection(),this._generateMachinesSection(),this._generateServicesSection(),this._generateBudgetSection(),this._generatePaymentSection(),this._generateDeploySection(),this._generateLogin()))}}DeploymentFlow.propTypes={WebHandler:PropTypes.func.isRequired,acl:PropTypes.object.isRequired,addAgreement:PropTypes.func.isRequired,addNotification:PropTypes.func.isRequired,addSSHKeys:PropTypes.func.isRequired,applications:PropTypes.array.isRequired,changeState:PropTypes.func.isRequired,changes:PropTypes.object.isRequired,changesFilterByParent:PropTypes.func.isRequired,charms:PropTypes.object.isRequired,charmsGetById:PropTypes.func.isRequired,charmstore:PropTypes.object.isRequired,cloud:PropTypes.object,controllerIsReady:PropTypes.func.isRequired,createCardElement:PropTypes.func,createToken:PropTypes.func,createUser:PropTypes.func,credential:PropTypes.string,ddData:PropTypes.object,deploy:PropTypes.func.isRequired,formatConstraints:PropTypes.func.isRequired,generateAllChangeDescriptions:PropTypes.func.isRequired,generateChangeDescription:PropTypes.func.isRequired,generateCloudCredentialName:PropTypes.func.isRequired,generateMachineDetails:PropTypes.func.isRequired,generatePath:PropTypes.func.isRequired,getAgreementsByTerms:PropTypes.func.isRequired,getCloudCredentialNames:PropTypes.func,getCloudCredentials:PropTypes.func,getCloudProviderDetails:PropTypes.func.isRequired,getCountries:PropTypes.func,getCurrentChangeSet:PropTypes.func.isRequired,getDiagramURL:PropTypes.func,getEntity:PropTypes.func,getGithubSSHKeys:PropTypes.func.isRequired,getSLAMachineRates:PropTypes.func,getServiceByName:PropTypes.func.isRequired,getUser:PropTypes.func,getUserName:PropTypes.func.isRequired,gisf:PropTypes.bool,groupedChanges:PropTypes.object.isRequired,gtmEnabled:PropTypes.bool,importSSHKeys:PropTypes.func.isRequired,isLoggedIn:PropTypes.func.isRequired,listBudgets:PropTypes.func.isRequired,listClouds:PropTypes.func,listPlansForCharm:PropTypes.func.isRequired,loginToController:PropTypes.func.isRequired,makeEntityModel:PropTypes.func.isRequired,modelCommitted:PropTypes.bool,modelName:PropTypes.string.isRequired,profileUsername:PropTypes.string.isRequired,region:PropTypes.string,renderMarkdown:PropTypes.func.isRequired,sendAnalytics:PropTypes.func.isRequired,setModelName:PropTypes.func.isRequired,showPay:PropTypes.bool,showTerms:PropTypes.func.isRequired,sortDescriptionsByApplication:PropTypes.func.isRequired,staticURL:PropTypes.string.isRequired,stats:PropTypes.object,updateCloudCredential:PropTypes.func,updateModelName:PropTypes.func,username:PropTypes.string,validateForm:PropTypes.func.isRequired,withPlans:PropTypes.bool},module.exports=DeploymentFlow;