'use strict';const classNames=require('classnames'),PropTypes=require('prop-types'),React=require('react'),AccordionSection=require('../../accordion-section/accordion-section'),CopyToClipboard=require('../../copy-to-clipboard/copy-to-clipboard'),EntityContentConfigOption=require('./config-option/config-option'),EntityContentDescription=require('./description/description'),EntityContentDiagram=require('./diagram/diagram'),EntityContentReadme=require('./readme/readme'),EntityContentRelations=require('./relations/relations'),ExpertContactCard=require('../../expert-contact-card/expert-contact-card'),EntityFiles=require('./files/files'),EntityResources=require('./resources/resources'),Spinner=require('../../spinner/spinner'),TermsPopup=require('../../terms-popup/terms-popup');class EntityContent extends React.Component{constructor(){super(),this.xhrs=[],this.state={terms:[],termsLoading:!1}}componentWillMount(){this._getTerms()}componentWillUnmount(){this.xhrs.forEach((a)=>{a&&a.abort&&a.abort()})}_getTerms(){const a=this.props.entityModel.get('terms');return a&&a.length?void this.setState({termsLoading:!0},()=>{a.forEach((b)=>{const c=this.props.showTerms(b,null,(c,d)=>{if(c){const a=`Failed to load terms for ${b}`;return this.props.addNotification({title:a,message:`${a}: ${c}`,level:'error'}),console.error(`${a}: ${c}`),void this.setState({termsLoading:!1})}const e=this.state.terms;e.push(d),this.setState({terms:e},()=>{e.length===a.length&&this.setState({termsLoading:!1})})});this.xhrs.push(c)})}):(this.setState({termsLoading:!1}),null)}_generateCharmConfig(a){var b=a.get('options');if(b){var c=[];return Object.keys(b).forEach(function(a){var d=b[a];d.name=a,c.push(React.createElement(EntityContentConfigOption,{key:a,option:d}))},this),React.createElement('dl',null,c)}}_generateBundleConfig(a){let b;if(b=a.get('applications'),!b)return;const c=a.toEntity();let d={};Array.isArray(c.applications)&&c.applications.forEach((a)=>{d[a.id]=a.iconPath});const e=Object.keys(b).map((a)=>{const c=b[a].options||{},e=b[a].charm.split('cs:').join('');let f=Object.keys(c).map((a,b)=>{return React.createElement('div',{className:'entity-content__config-option',key:a+b},React.createElement('dt',{className:'entity-content__config-name'},a),React.createElement('dd',{className:'entity-content__config-description'},React.createElement('p',null,c[a])))});0===f.length&&(f=null);const g=React.createElement('span',null,React.createElement('img',{alt:a,className:'entity-content__config-image',src:d[e],width:'26'}),a);return f&&(f=React.createElement('div',{className:'entity-content__config-description'},f)),React.createElement(AccordionSection,{key:a,title:g},f)});return React.createElement('div',null,e)}_generateOptionsList(a){let b;const c='charm'===a.get('entityType');if(b=c?this._generateCharmConfig(a):this._generateBundleConfig(a),b){const a=c?'Configuration':'Bundle configuration';return React.createElement('div',{className:'entity-content__configuration',id:'configuration'},React.createElement('h3',{className:'entity-content__header'},a),b)}}_generateList(a,b){return a.map(function(a,c){return[0<c?', ':''].concat(React.createElement('a',{className:'link',"data-id":a,key:a+c,onClick:b},a))})}_generateTags(){var a,b=[],c=this.props.entityModel.get('tags');if(c){for(a in c)b.push(c[a]);return React.createElement('div',{className:'entity-content__metadata'},React.createElement('h4',{className:'entity-content__metadata-title'},'Tags:'),'\xA0',this._generateList(b,this._handleTagClick.bind(this)))}}_handleTagClick(a){a.stopPropagation(),this.props.changeState({hash:null,search:{tags:a.target.getAttribute('data-id'),text:''},store:null})}_generateTerms(){const a=this.state.terms;let b;if(this.state.termsLoading)b=React.createElement(Spinner,null);else{if(0===a.length)return null;b=a.map((a,b)=>{return[0<b?', ':''].concat(React.createElement('a',{className:'link',key:a.name,onClick:this._toggleTerms.bind(this,a)},a.name))})}return React.createElement('div',{className:'entity-content__metadata'},React.createElement('h4',{className:'entity-content__metadata-title'},'Terms:'),'\xA0',b)}_toggleTerms(a=null){this.setState({showTerms:a})}_generateTermsPopup(){const a=this.state.showTerms;return a?React.createElement(TermsPopup,{close:this._toggleTerms.bind(this),terms:[a]}):null}_generateDescription(a){return React.createElement(EntityContentDescription,{changeState:this.props.changeState,description:a.get('description'),includeHeading:!0,renderMarkdown:this.props.renderMarkdown})}_generateDiagram(a){if('bundle'===a.get('entityType')){const b=a.toEntity();return React.createElement(EntityContentDiagram,{clearLightbox:this.props.clearLightbox,diagramUrl:this.props.getDiagramURL(a.get('id')),displayLightbox:this.props.displayLightbox,isExpandable:!0,isRow:!1,title:b.displayName})}}_generateTagsAndTerms(){return!('charm'!==this.props.entityModel.get('entityType'))&&React.createElement('div',{className:'entity-content__terms'},this._generateTags(),this._generateTerms())}_generateResources(){var a=this.props.entityModel;if('charm'===a.get('entityType'))return React.createElement(EntityResources,{apiUrl:this.props.apiUrl,entityId:a.get('id'),pluralize:this.props.pluralize,resources:a.get('resources')})}_showEntityRelations(){var a=this.props.entityModel;if('charm'===a.get('entityType')){var b=a.get('relations'),c=b.requires||{},d=b.provides||{},e=Object.keys(c).concat(Object.keys(d));if(0<e.length)return React.createElement(EntityContentRelations,{changeState:this.props.changeState,relations:b})}}_generateActions(){const a=this.props.entityModel.getAttrs();let b=a.bugUrl,c=a.homepage;return'bundle'!==a.entityType||c?'charm'===a.entityType&&!b&&(b='https://bugs.launchpad.net/charms/'+`+source/${a.name}`):c='https://code.launchpad.net/'+`~charmers/charms/bundles/${a.name}/bundle`,React.createElement('div',{className:'section section__contribute'},React.createElement('h3',{className:'section__title'},'Contribute'),React.createElement('ul',{className:'section__list'},b?React.createElement('li',{className:'section__list-item'},React.createElement('a',{className:'link',href:b,target:'_blank'},'Submit a bug')):void 0,c?React.createElement('li',{className:'section__list-item'},React.createElement('a',{className:'link',href:c,target:'_blank'},'Project homepage')):void 0))}_generateExpert(){const a=this.props.entityModel;return this.props.hasPlans||'charm'!==a.get('entityType')?React.createElement(ExpertContactCard,{expert:a.get('owner'),sendAnalytics:this.props.sendAnalytics,staticURL:this.props.staticURL}):null}_generatePriceList(a){var a=a.split(';'),b=[];return a.forEach((a,c)=>{if(''!==a){var d,[e,f]=a.split('/');f&&(d=React.createElement('span',{className:'entity-content__plan-price-quantity'},'/ ',f)),b.push(React.createElement('li',{className:'entity-content__plan-price-item',key:e+(f||'')+c},React.createElement('span',{className:'entity-content__plan-price-amount'},e),d))}}),b}_generatePlans(){var a=this.props;if('charm'===a.entityModel.get('entityType')&&this.props.hasPlans){var b=a.plans;if(!b)return React.createElement(Spinner,null);if(b.length){var c=[];return b.forEach((a,b)=>{var d=classNames('entity-content__plan','four-col',{"last-col":0==(b+1)%3});c.push(React.createElement('div',{className:d,key:a.url+b},React.createElement('div',{className:'entity-content__plan-content'},React.createElement('h3',{className:'entity-content__plan-title'},a.url),React.createElement('ul',{className:'entity-content__plan-price'},this._generatePriceList(a.price)),React.createElement('p',{className:'entity-content__plan-description'},a.description))))}),React.createElement('div',{className:'row entity-content__plans',id:'plans'},React.createElement('div',{className:'inner-wrapper'},React.createElement('div',{className:'twelve-col'},React.createElement('h2',{className:'entity-content__header'},'Plans'),React.createElement('div',{className:'equal-height'},c))))}}}_generateCard(){const a=this.props.entityModel,b=a.toEntity(),c='charm'===b.type?b.storeId:b.id.split('cs:').join(''),d=this.props.flags['test.ddeploy'],e=d?'data-dd':'',f='<script src="https://assets.ubuntu.com/v1/juju-cards-v1.6.0.js"></script>\n'+`<div class="juju-card" ${e} data-id="${c}"></div>`;let g=React.createElement('div',{className:'juju-card',"data-id":c});return d&&(g=React.createElement('div',{className:'juju-card',"data-dd":!0,"data-id":c})),React.createElement('div',{className:'entity-content__card section clearfix'},React.createElement('h3',{className:'section__title'},'Embed this charm'),React.createElement('p',null,'Add this card to your website by copying the code below.\xA0',React.createElement('a',{className:'entity-content__card-cta',href:'https://jujucharms.com/community/cards',target:'_blank'},'Learn more'),'.'),React.createElement(CopyToClipboard,{className:'copy-to-clipboard',value:f}),React.createElement('h4',null,'Preview'),g)}componentDidMount(){window.jujuCards&&window.jujuCards()}render(){const a=this.props.entityModel;return React.createElement('div',{className:'entity-content'},React.createElement('div',{className:'row'},React.createElement('div',{className:'inner-wrapper'},React.createElement('div',{className:'eight-col'},this._generateDescription(a),this._generateDiagram(a),this._generateTagsAndTerms(a),this._generatePlans(),React.createElement(EntityContentReadme,{addNotification:this.props.addNotification,changeState:this.props.changeState,entityModel:a,getFile:this.props.getFile,hash:this.props.hash,renderMarkdown:this.props.renderMarkdown,scrollCharmbrowser:this.props.scrollCharmbrowser}),this._generateOptionsList(a)),React.createElement('div',{className:'four-col last-col'},this._generateExpert(),this._generateActions(),this._generateResources(),this._showEntityRelations(),React.createElement(EntityFiles,{apiUrl:this.props.apiUrl,entityModel:a,pluralize:this.props.pluralize}),this._generateCard()))),this._generateTermsPopup())}}EntityContent.defaultProps={flags:{}},EntityContent.propTypes={addNotification:PropTypes.func.isRequired,apiUrl:PropTypes.string.isRequired,changeState:PropTypes.func.isRequired,clearLightbox:PropTypes.func,displayLightbox:PropTypes.func,entityModel:PropTypes.object.isRequired,flags:PropTypes.object,getDiagramURL:PropTypes.func.isRequired,getFile:PropTypes.func.isRequired,hasPlans:PropTypes.bool.isRequired,hash:PropTypes.string,plans:PropTypes.array,pluralize:PropTypes.func.isRequired,renderMarkdown:PropTypes.func.isRequired,scrollCharmbrowser:PropTypes.func.isRequired,sendAnalytics:PropTypes.func.isRequired,showTerms:PropTypes.func.isRequired,staticURL:PropTypes.string},module.exports=EntityContent;