'use strict';const classNames=require('classnames'),PropTypes=require('prop-types'),React=require('react'),CopyToClipboard=require('../../copy-to-clipboard/copy-to-clipboard'),GenericButton=require('../../generic-button/generic-button'),SvgIcon=require('../../svg-icon/svg-icon');class EntityHeader extends React.Component{constructor(){super(),this.state={headerHeight:0}}componentDidMount(){this.setState({headerHeight:this.refs.headerWrapper.clientHeight})}_handleDeployClick(){const a=this.props,b=a.entityModel,c=b.toEntity();if('charm'===c.type){const c=this.refs,d=a.plans,e=c.plan&&c.plan.value;let f;e&&Array.isArray(d)&&d.some((a)=>{if(a.url===e)return f=a,!0}),a.deployService(b,void 0,d,f)}else{const b=a.urllib.fromLegacyString(c.id);a.getBundleYAML(b.legacyPath(),this._getBundleYAMLCallback.bind(this,b.path()))}this._closeEntityDetails()}_closeEntityDetails(){this.props.changeState({hash:null,store:null,postDeploymentPanel:{entityId:this.props.entityModel.toEntity().id}})}_getBundleYAMLCallback(a,b,c){return b?(console.error(b),void this.props.addNotification({title:'Bundle failed to deploy',message:'The bundle '+this.props.entityModel.get('name')+' failed to deploy:'+b,level:'error'})):void(this.props.importBundleYAML(c,a),this._closeEntityDetails())}_getStoreURL(a){var b=['https://jujucharms.com'];return 0<=a.id.indexOf('~')&&(b.push('u'),b.push(a.owner)),b.push(a.name),b.push(a.series),b.push(a.revision),encodeURIComponent(b.join('/'))}_generateWrapperStyles(){return 0<this.state.headerHeight?{height:this.state.headerHeight+'px'}:{}}_generateClasses(){return classNames('entity-header',{"entity-header--sticky":this.props.scrollPosition>this.state.headerHeight})}_generateDeployAction(){const a=this.props.entityModel.toEntity();let b;const c=this.props.getModelName(),d=`Add to ${c||'model'}`;return b='charm'!==a.type||a.series?React.createElement(GenericButton,{action:this._handleDeployClick.bind(this),disabled:this.props.acl.isReadOnly(),ref:'deployAction',tooltip:`Add this ${a.type} to `+`${c?'your current':'a new'} model`,type:'positive'},d):React.createElement('div',{className:'entity-header__deploy-action',ref:'deployAction'},'This type of charm can only be deployed from the command line.'),b}_generateSelectPlan(){var a=this.props;if('charm'===a.entityModel.get('entityType')&&this.props.hasPlans){var b=a.plans,c=null,d='';if(!b)d='Loading plans...';else{if(!b.length)return;d='Choose a plan',c=[],b.forEach((a,b)=>{c.push(React.createElement('option',{key:a.url+b,value:a.url},a.url))})}return React.createElement('select',{className:'entity-header__select',ref:'plan'},React.createElement('option',{key:'default'},d),c)}}_generateCounts(){var a=this.props.entityModel.toEntity();if('bundle'===a.type){var b=a.serviceCount,c=a.unitCount,d=a.machineCount;return React.createElement('ul',{className:'bullets inline entity-header__properties'},React.createElement('li',{className:'entity-header__counts'},b,' ',this.props.pluralize('application',b),', \xA0',d,' ',this.props.pluralize('machine',d),', \xA0',c,' ',this.props.pluralize('unit',c)))}}_generateSubordinate(){const a=this.props.entityModel.get('is_subordinate');return a?React.createElement('li',{className:'entity-header__subordinate'},'Subordinate',React.createElement('a',{href:'https://jujucharms.com/docs/stable/authors-subordinate-applications',target:'_blank'},React.createElement(SvgIcon,{name:'help_16',size:'16'}))):null}_generateLatestRevision(){const a=this.props,b=a.entityModel,c=b.get('revisions');if(!c||!c.length)return console.warn('revision information is not available'),null;const d=c[0];if(d===b.get('id'))return null;const e=a.urllib.fromLegacyString(d);return React.createElement('li',{className:'entity-header__series',key:d},React.createElement('span',{className:'link',onClick:this._onLastRevisionClick.bind(this)},'Latest version (#',e.revision,')'))}_onLastRevisionClick(a){a.preventDefault(),a.stopPropagation();const b=this.props,c=b.entityModel.get('revisions'),d=b.urllib.fromLegacyString(c[0]);b.changeState({store:d.path()})}_onOwnerClick(a){a.preventDefault(),a.stopPropagation();const b=this.props,c=b.entityModel;b.changeState({hash:null,store:null,profile:c.get('owner')})}_generateSeriesList(){var a=this.props.entityModel.get('series');return a?(a=Array.isArray(a)?a:[a],a.map((a)=>React.createElement('li',{className:'entity-header__series',key:a},a))):null}_generateChannelList(){const a=this.props.entityModel.get('channels').filter((a)=>{return a.current});if(!a.length)return null;const b=a.map((a)=>{const b=a.name;return b.charAt(0).toUpperCase()+b.slice(1)}).join(', ');return React.createElement('li',{className:'entity-header__channels',key:b},b)}render(){let a;const b=this.props.entityModel,c=b.toEntity(),d=['https://twitter.com/intent/tweet?text=',c.displayName,'%20charm&via=ubuntu_cloud&url=',this._getStoreURL(c)].join(''),e=['https://plus.google.com/share?url=',this._getStoreURL(c)].join('');return'bundle'!==c.type&&(a=React.createElement('img',{alt:c.displayName,className:'entity-header__icon',src:c.iconPath,width:'96'})),React.createElement('div',{className:'row-hero',ref:'headerWrapper',style:this._generateWrapperStyles()},React.createElement('header',{className:this._generateClasses()},React.createElement('div',{className:'inner-wrapper'},React.createElement('div',{className:'eight-col no-margin-bottom'},a,React.createElement('h1',{className:'entity-header__title',itemProp:'name',ref:'entityHeaderTitle'},c.displayName,' ',React.createElement('span',{className:'entity-header__version'},'#',c.revision_id)),React.createElement('ul',{className:'bullets inline entity-header__properties'},React.createElement('li',{className:'entity-header__by'},'By\xA0',React.createElement('span',{className:'link',onClick:this._onOwnerClick.bind(this)},c.owner)),this._generateSubordinate(),this._generateLatestRevision(),this._generateSeriesList(),this._generateChannelList()),this._generateCounts(),React.createElement('ul',{className:'entity-header__social-list'},React.createElement('li',null,React.createElement('a',{href:d,id:'item-twitter',target:'_blank'},React.createElement(SvgIcon,{name:'icon-social-twitter',size:'36'}))),React.createElement('li',null,React.createElement('a',{href:e,id:'item-googleplus',target:'_blank'},React.createElement(SvgIcon,{name:'icon-social-google',size:'36'}))))),React.createElement('div',{className:'entity-header__right four-col last-col no-margin-bottom'},this._generateSelectPlan(),React.createElement(CopyToClipboard,{value:'juju deploy '+c.id}),this._generateDeployAction()))))}}EntityHeader.propTypes={acl:PropTypes.object.isRequired,addNotification:PropTypes.func.isRequired,changeState:PropTypes.func.isRequired,deployService:PropTypes.func.isRequired,entityModel:PropTypes.object.isRequired,getBundleYAML:PropTypes.func.isRequired,getModelName:PropTypes.func.isRequired,hasPlans:PropTypes.bool.isRequired,importBundleYAML:PropTypes.func.isRequired,plans:PropTypes.array,pluralize:PropTypes.func.isRequired,scrollPosition:PropTypes.number.isRequired,urllib:PropTypes.func.isRequired},module.exports=EntityHeader;