'use strict';const PropTypes=require('prop-types'),React=require('react'),BasicTable=require('../../basic-table/basic-table'),CreateModelButton=require('../../create-model-button/create-model-button'),DateDisplay=require('../../date-display/date-display'),Popup=require('../../popup/popup'),Spinner=require('../../spinner/spinner'),SvgIcon=require('../../svg-icon/svg-icon');class ProfileModelList extends React.Component{constructor(){super(),this.state={loadingModels:!1,models:null,notification:null}}componentWillMount(){this._fetchModels(this.props.facadesExist)}componentWillReceiveProps(a){const b=this.props;(b.userInfo.profile!==a.userInfo.profile||b.facadesExist!==a.facadesExist)&&this._fetchModels(a.facadesExist)}_fetchModels(a){return a?void this.setState({loadingModels:!0},()=>{this.props.listModelsWithInfo(this._fetchModelsCallback.bind(this))}):void console.warn('Controller not connected, skipping fetching models.')}_fetchModelsCallback(a,b){this.setState({loadingModels:!1},()=>{if(a){const b='Cannot load models';return console.error(b,a),void this.props.addNotification({title:b,message:`${b}: ${a}`,level:'error'})}this.setState({models:b})})}_showConfirmation(a){const b=`Are you sure you want to destroy ${a.name}?`+' All the applications and units included in the model will be destroyed. This action cannot be undone.';this.setState({notification:React.createElement(Popup,{buttons:[{title:'Cancel',action:()=>this.setState({notification:null}),type:'inline-neutral'},{title:'Destroy',action:()=>{this.setState({notification:null}),this.props.destroyModel(a.uuid,()=>{this._fetchModels(this.props.facadesExist)},!1)},type:'destructive'}],title:'Destroy model'},React.createElement('p',null,b))})}_destroyModel(a,b,c){return c.preventDefault(),c.stopPropagation(),a.isController?void this.props.addNotification({title:'Cannot destroy model',message:'The controller model cannot be destroyed.',level:'error'}):void this._showConfirmation(a)}_handleCredentialClick(a){this.props.changeState({hash:`credentials/${a}`})}_generateModels(){const a=new Map([['read','show_16'],['write','edit_16'],['admin','user_16']]),b=this.props.userInfo.profile,c=this.state.models||[];return c.reduce((c,d,e)=>{if(!d.isAlive)return c;const f=d.users.find((a)=>a.displayName===b);if(void 0===f)return c;const g=`mymodel-button-dropdown-${e}`,h=d.owner.replace('@external','')||b,i=`${this.props.baseURL}u/${h}/${d.name}`,j='admin'===f.access,k=h===b?'Me':h,l=d.region?'/'+d.region:'',m=React.createElement('a',{href:i,onClick:this.switchToModel.bind(this,{name:d.name,id:d.id,owner:h})},d.name),n=React.createElement('div',null,React.createElement('span',{className:'profile-model-list__machine-number'},d.numMachines),d.cloud||d.provider,l),o=React.createElement('div',{className:'profile-model-list__access tooltip'},React.createElement('span',{className:'tooltip__tooltip'},React.createElement('span',{className:'tooltip__inner tooltip__inner--down'},f.access)),React.createElement(SvgIcon,{name:a.get(f.access),size:'16'})),p=React.createElement(DateDisplay,{date:d.lastConnection||'--',relative:!0}),q=j&&!d.isController?React.createElement('a',{onClick:this._destroyModel.bind(this,d,g)},React.createElement(SvgIcon,{name:'delete_16',size:'16'})):null;let r;return r=h===b?React.createElement('div',{className:'three-col prepend-five profile-model-list__credential-name'},React.createElement('span',{className:'link',onClick:this._handleCredentialClick.bind(this,d.credential),role:'button',tabIndex:'0'},d.credentialName)):React.createElement('div',{className:'twelve-col'},'No additional information available on shared model.'),c.push({columns:[{content:m,columnSize:3},{content:k,columnSize:2},{content:n,columnSize:3},{content:o,columnSize:1},{content:p,columnSize:2},{content:q,columnSize:1,classes:['u-text-align--right']}],expandedContent:React.createElement('div',{className:'profile-model-list__expanded-content'},React.createElement('div',{className:'three-col'},m),React.createElement('div',{className:'two-col'},k),React.createElement('div',{className:'three-col'},n),React.createElement('div',{className:'one-col'},o),React.createElement('div',{className:'two-col'},p),React.createElement('div',{className:'one-col last-col u-text-align--right'},q),r),key:d.name}),c},[])||[]}switchToModel(a,b){b.preventDefault(),b.stopPropagation(),this.props.changeState({profile:null}),this.props.switchModel(a)}_generateNotification(){return this.state.notification?this.state.notification:void 0}render(){if(this.state.loadingModels)return React.createElement('div',{className:'profile-model-list'},React.createElement(Spinner,null));const a=this._generateModels();return React.createElement('div',{className:'profile-model-list'},React.createElement('div',{className:'profile-model-list__header twelve-col'},React.createElement(CreateModelButton,{changeState:this.props.changeState,switchModel:this.props.switchModel,title:'Start a new model'}),React.createElement('h2',{className:'profile__title'},'My models',React.createElement('span',{className:'profile__title-count'},'(',a.length,')'))),a.length?React.createElement(BasicTable,{headerClasses:['profile__entity-table-header-row'],headerColumnClasses:['profile__entity-table-header-column'],headers:[{content:'Name',columnSize:3},{content:'Owner',columnSize:2},{content:'Machines, cloud/region',columnSize:3},{content:'',columnSize:1},{content:'Last accessed',columnSize:2},{content:'',columnSize:1}],rowClasses:['profile__entity-table-row'],rowColumnClasses:['profile__entity-table-column'],rows:a}):null,this._generateNotification())}}ProfileModelList.propTypes={acl:PropTypes.object,addNotification:PropTypes.func.isRequired,baseURL:PropTypes.string.isRequired,changeState:PropTypes.func.isRequired,destroyModel:PropTypes.func.isRequired,facadesExist:PropTypes.bool.isRequired,listModelsWithInfo:PropTypes.func.isRequired,models:PropTypes.array,switchModel:PropTypes.func.isRequired,userInfo:PropTypes.object.isRequired},module.exports=ProfileModelList;