'use strict';const d3=require('d3'),React=require('react'),ReactDOM=require('react-dom'),endpointUtils=require('../endpoint-utils'),relationUtils=require('../relation-utils'),topoUtils=require('./utils'),environmentUtils=require('./environment-utils'),utils=require('../../views/utils'),AmbiguousRelationMenu=require('../../components/relation-menu/ambiguous-relation-menu'),RelationMenu=require('../../components/relation-menu/relation-menu');class RelationModule{constructor(){this.name='RelationModule',this.relations=[],this.events={scene:{".rel-indicator":{click:'relationClick',mousemove:'mousemove'},".relation-remove":{click:{callback:'relationRemoveClick'}},".inspect-relation":{click:{callback:'inspectRelationClick'}},".dragline":{click:{callback:'draglineClicked'}},".zoom-plane":{mousemove:{callback:'mousemove'}}},topo:{addRelationDrag:'addRelationDrag',addRelationDragEnd:'addRelationDragEnd',addRelationDragStart:'addRelationDragStart',cancelRelationBuild:'cancelRelationBuild',clearState:'clearState',fade:'hide',mouseMove:'mouseMoveHandler',rendered:'renderedHandler',rerenderRelations:'rerender',serviceMoved:'updateLinkEndpoints',servicesRendered:'updateLinks',show:'show',snapOutOfService:'snapOutOfService',snapToService:'snapToService'}}}render(){return this}update(){const a=this.topo,b=a.db,c=b.relations.toArray();return this.relations=this.decorateRelations(c),this.updateLinks(),this.updateSubordinateRelationsCount(),this.updateRelationVisibility(),this}rerender(){const a=this.topo;a.vis.selectAll('.rel-group').remove(),this.update()}getContainer(){const a=this.topo.container;return a.getDOMNode&&a.getDOMNode()||a}renderedHandler(){this.update()}processRelation(a){const b=this,c=b.topo,d=a.get('endpoints'),e=[];return d.forEach((a)=>{e.push([a[1].name,c.service_boxes[a[0]]])}),e}decorateRelations(a){const b=this,c=[];return a.forEach((a)=>{const d=b.processRelation(a);if(2===d.length){const b=d[0][1],e=d[1][1];if(!b||!e)return;const f=relationUtils.DecoratedRelation(a,b,e);c.push(f)}}),relationUtils.toRelationCollections(c)}updateLinks(){const a=this.drawRelationGroup();a.each(this.drawRelation),this.relationMenuActive&&this.showRelationMenu(this.relationMenuRelation),a.exit().remove()}updateLinkEndpoints(a){const b=this,c=a.service,d=b.topo,e=d._yuid;c.relations&&0!==c.relations.size()&&b.relations.filter((a)=>{return a.source.id===c.id||a.target.id===c.id}).forEach((a)=>{const b=d.vis.select('#'+relationUtils.generateSafeDOMId(a.id,e)),c=a.source.getConnectorPair(a.target),f=c[0],g=c[1];b.select('line').attr('x1',f[0]).attr('y1',f[1]).attr('x2',g[0]).attr('y2',g[1])})}drawRelationGroup(){const a=this,b=this.topo;let c=b.staticURL||'';c&&(c+='/');const e=`${c}static/gui/build/app`,d=b.vis,f=b._yuid,h=20,i=d.selectAll('g.rel-group').data(a.relations,function(a){return a.compositeId}),g=i.enter().insert('g','g.service').attr('id',function(a){return relationUtils.generateSafeDOMId(a.id,f)}).classed('rel-group',!0);return g.append('svg:line','g.service').attr('class',function(a){return'relation '+a.aggregatedStatus}),g.append('circle').attr({cx:0,cy:0,r:4,'class'(a){return'connector1 '+a.aggregatedStatus}}),g.append('circle').attr({cx:0,cy:0,r:4,'class'(a){return'connector2 '+a.aggregatedStatus}}),g.append('g').classed('rel-indicator',!0).append('image').attr({width:h,height:h,x:h/-2,y:h/-2,rx:h/2,ry:h/2}),g.append('text').append('tspan').text(function(a){return a.display_name}),i.filter(function(a){let b=d3.select(this).select('image').attr('xlink:href')||'';return b=b.split('relation-icon-').reverse()[0].split('.')[0],b!==a.aggregatedStatus}).selectAll('image').attr('xlink:href',function(a){return e+'/assets/svgs/relation-icon-'+a.aggregatedStatus+'.svg'}),i}drawRelation(a){var b=Math.sin,c=Math.cos;const d=a.source.getConnectorPair(a.target),e=d[0],f=d[1],g=d3.select(this).select('line'),h=d3.select(this).select('.connector1'),i=d3.select(this).select('.connector2'),j=d3.select(this).select('.rel-indicator'),k=a.source.w/2-4,l=a.target.w/2-4;g.attr('x1',e[0]).attr('y1',e[1]).attr('x2',f[0]).attr('y2',f[1]).attr('class',function(){return'relation '+a.aggregatedStatus});const m=Math.atan2(e[1]-f[1],e[0]-f[0]),n=[e[0]+-(c(m)*k),e[1]+-(b(m)*k)],o=[f[0]+c(m)*l,f[1]+b(m)*l];return h.attr('cx',n[0]).attr('cy',n[1]),i.attr('cx',o[0]).attr('cy',o[1]),j.attr('transform',function(){var a=Math.abs,b=Math.max;return'translate('+[b(n[0],o[0])-a((n[0]-o[0])/2),b(n[1],o[1])-a((n[1]-o[1])/2)]+')'}),g}updateSubordinateRelationsCount(){const a=this.topo,b=a.vis,c=this;b.selectAll('.service.subordinate').selectAll('.sub-rel-block tspan').text(function(a){return c.subordinateRelationsForService(a).length})}draglineClicked(){document.dispatchEvent(new Event('topo.clearState'))}mousemove(a,b){b.clickAddRelation&&b.addRelationDrag.call(b,{box:b.addRelationStart_service})}mouseMoveHandler(){const a=this.getContainer();this.mousemove.call(a.querySelector('.zoom-plane'),null,this)}snapToService(a){const b=a.service,c=a.rect;if(b!==this.addRelationStart_service&&(this.potential_drop_point_service=b,this.potential_drop_point_rect=c,topoUtils.addSVGClass(c,'hover'),this.dragline)){const a=b.getConnectorPair(this.addRelationStart_service),c=a[0],d=a[1];this.dragline.select('line').attr('x1',d[0]).attr('y1',d[1]).attr('x2',c[0]).attr('y2',c[1]).attr('class','relation pending-relation dragline'),this.draglineOverService=!0}}snapOutOfService(){this.clearRelationSettings(),this.dragline&&(this.dragline.select('line').attr('class','relation pending-relation dragline dragging'),this.draglineOverService=!1,this.clickAddRelation=!0,this.topo.buildingRelation=!0)}addRelationDragStart(a){if(!this.dragline){let b=this.topo.staticURL||'';b&&(b+='/');const c=`${b}static/gui/build/app`,e=a.service,d=this.topo.vis,f=d.insert('g',':first-child').attr('class','drag-relation-group');f.insert('line').attr('class','relation pending-relation dragline dragging'),f.append('circle').attr('class','dragline__indicator').attr({r:15,fill:'#ffffff',stroke:'#888888',"stroke-width":1.1}),f.append('image').attr('class','dragline__indicator-image').attr({"xlink:href":`${c}/assets/svgs/build-relation_16.svg`,width:16,height:16,transform:'translate(-8, -8)'}),this.dragplane=document.querySelector('.the-canvas g');const g=d3.mouse(this.dragplane);this.cursorBox=new environmentUtils.BoundingBox,this.cursorBox.pos={x:g[0],y:g[1],w:0,h:0};const h=this.cursorBox.getConnectorPair(e),i=h[0][0]-8+', '+(h[0][1]-8);f.select('line').classed('dragline__line',!0).attr('x1',h[0][0]).attr('y1',h[0][1]).attr('x2',h[1][0]).attr('y2',h[1][1]),f.select('circle').attr('cx',h[0][0]).attr('cy',h[0][1]),f.select('image').attr('transform','translate('+i+')'),this.dragline=f,d.select('.plus-service').classed('fade',!0),this.addRelationStart(e,this)}}addRelationDrag(a){const b=a.box;if(!b||!this.dragline)return void this.clearRelationSettings();if(!this.draglineOverService){const c=d3.mouse(this.dragplane),d=c[0],e=c[1];if(!this.cursorBox&&(this.addRelationDragStart(a),!this.cursorBox))return;this.cursorBox.pos={x:d,y:e,w:0,h:0};const f=this.cursorBox.getConnectorPair(b),g=f[1];this.dragline.select('line').attr('x1',g[0]).attr('y1',g[1]).attr('x2',d).attr('y2',e),this.dragline.select('circle').attr('cx',d).attr('cy',e),this.dragline.select('image').attr('transform','translate('+(d-8+', '+(e-8))+')')}}addRelationDragEnd(){const a=this,b=a.topo,c=a.potential_drop_point_rect,d=a.potential_drop_point_service;b.buildingRelation=!1,a.cursorBox=null,c?a.ambiguousAddRelationCheck(d,a,c):a.cancelRelationBuild()}clearState(){this.clearRelationSettings(),this.cancelRelationBuild(),this.relationMenuActive=!1,this.relationMenuRelation=void 0}cancelRelationBuild(){const a=this.topo,b=a.vis;this.dragline&&(this.dragline.remove(),this.dragline=null),this.clickAddRelation=null,a.buildingRelation=!1,a.update(),b.selectAll('.service').classed('selectable-service',!1),b.selectAll('.plus-service').classed('fade',!1)}clearRelationSettings(){const a=this.topo;a.buildingRelation=!1,this.clickAddRelation=null,this.draglineOverService=!1,this.potential_drop_point_service=void 0,this.potential_drop_point_rect=void 0}updateRelationVisibility(){const a=this.topo.db,b={fade:[],show:[],hide:[]};let c;a.services.each(function(a){c=a.get('id'),a.get('fade')&&b.fade.push(c),a.get('hide')&&b.hide.push(c),a.get('fade')||a.get('hide')||b.show.push(c)}),0<b.fade.length&&this.fade({serviceNames:b.fade}),0<b.hide.length&&this.hide({serviceNames:b.hide}),0<b.show.length&&this.show({serviceNames:b.show})}show(a){let b=a.serviceNames;const c=this.topo;b&&0!==b.length||(b=Object.keys(c.service_boxes));const d=c.vis.selectAll('.rel-group').filter(function(a){return(-1<b.indexOf(a.source.id)||-1<b.indexOf(a.target.id))&&!1===a.target.hide&&!1===a.source.hide&&!1===a.target.fade&&!1===a.source.fade});d.classed(topoUtils.getVisibilityClasses('show'))}fade(a){const b=a.serviceNames;if(b){const a=this.topo,c=a.vis.selectAll('.rel-group').filter(function(a){return-1<b.indexOf(a.source.id)||-1<b.indexOf(a.target.id)});c.classed(topoUtils.getVisibilityClasses('fade'))}}hide(a){const b=a.serviceNames;if(b){const a=this.topo,c=a.vis.selectAll('.rel-group').filter(function(a){return-1<b.indexOf(a.source.id)||-1<b.indexOf(a.target.id)});c.classed(topoUtils.getVisibilityClasses('hide'))}}startRelation(a){const b=this.topo,c=b.vis;b.buildingRelation=!0,this.clickAddRelation=!0,document.dispatchEvent(new CustomEvent('topo.show',{detail:[{selection:c.selectAll('.service')}]}));const d=b.db,e=b.endpointsController,f=endpointUtils.getEndpoints(a,e),g=utils.arrayFlatten(Object.keys(f).map((a)=>f[a])).map((a)=>{return a.service}),h={};d.services.each(function(a){-1===g.indexOf(a.get('id'))&&(h[a.get('id')]=!0)});const i=c.selectAll('.service').classed('selectable-service',!0).filter(function(b){return b.id in h&&b.id!==a.get('id')});document.dispatchEvent(new CustomEvent('topo.fade',{detail:[{selection:i,serviceNames:Object.keys(h)}]})),i.classed('selectable-service',!1),this.addRelationStart_possibleEndpoints=f,this.currentServiceClickAction='ambiguousAddRelationCheck'}addRelationStart(a,b){const c=b.topo,d=c.serviceForBox(a);b.startRelation(d),b.addRelationStart_service=a}ambiguousAddRelationCheck(a,b,c){let d=b.addRelationStart_possibleEndpoints[a.id];const e=b.topo;if(d&&1===d.length){const a=d[0],e=[[a[0].service,{name:a[0].name,role:'server'}],[a[1].service,{name:a[1].name,role:'client'}]];return void b.addRelationEnd(e,b,c)}d=d.sort(function(c,a){return c[0].name+c[1].name<a[0].name+a[1].name}),d=this._getServiceDisplayName(d,e),b.clickAddRelation=null;const f=this._renderAmbiguousRelationMenu(d);this._attachAmbiguousReleationSelect(f,b,c),this._positionAmbiguousRelationMenu(f,e,a,c)}_getServiceDisplayName(a,b){let c,d;return a.map(function(a){return a.forEach(function(a){c=a.service,d=0<c.indexOf('$')?b.db.services.getById(c).get('displayName').replace(/^\(/,'').replace(/\)$/,''):c,a.displayName=d}),[a[0],a[1]]},this)}_renderAmbiguousRelationMenu(a){const b=this.getContainer(),c=b.querySelector('#ambiguous-relation-menu');return ReactDOM.render(React.createElement(AmbiguousRelationMenu,{endpoints:a}),c.querySelector('#ambiguous-relation-menu-content')),c}_attachAmbiguousReleationSelect(a,b,c){a.querySelectorAll('.menu li').forEach((d)=>{d.addEventListener('click',function(d){const e=d.currentTarget,f=[[e.getAttribute('data-startservice'),{name:e.getAttribute('data-startname'),role:'server'}],[e.getAttribute('data-endservice'),{name:e.getAttribute('data-endname'),role:'client'}]];a.classList.remove('active'),b.addRelationEnd(f,b,c)})}),a.querySelector('.cancel').addEventListener('click',function(){a.classList.remove('active'),b.cancelRelationBuild()})}_positionAmbiguousRelationMenu(a,b,c,d){const e=b.zoom.translate(),f=b.zoom.scale(),g=topoUtils.locateRelativePointOnCanvas(c,e,f);a.style.left=`${g[0]}px`,a.style.top=`${g[1]}px`,a.classList.add('active'),b.active_service=c,b.active_context=d}addRelationEnd(a,b){b.cancelRelationBuild(),b.clearRelationSettings();const c=b.topo;a[0][0]===a[1][0]||relationUtils.createRelation(c.db,c.env,a)}subordinateRelationsForService(a){return this.relations.filter(function(b){return(b.source.modelId===a.modelId||b.target.modelId===a.modelId)&&b.isSubordinate})}relationClick(a,b){b.showRelationMenu(a)}showRelationMenu(a){const b=document.querySelector('#relation-menu');ReactDOM.render(React.createElement(RelationMenu,{relations:a.relations}),b),b.classList.add('active'),this.relationMenuActive=!0,this.relationMenuRelation=a;const c=this.topo,d=c.zoom.translate(),e=c.zoom.scale(),f=a.source.getConnectorPair(a.target),g=topoUtils.findCenterPoint(f[0],f[1]),h={x:g[0],y:g[1],w:0,h:0},i=topoUtils.locateRelativePointOnCanvas(h,d,e);i[0]-=b.clientWidth/2,i[1]-=b.clientHeight+16,b.style.left=`${i[0]}px`,b.style.top=`${i[1]}px`,b.querySelector('.triangle').style.left=b.clientWidth/2-5}relationRemoveClick(a,b){const c=b.topo,d=c.db,e=this.closest('.relation-container').getAttribute('data-relationid');let f=d.relations.getById(e);f=b.decorateRelations([f])[0],document.dispatchEvent(new Event('topo.clearState')),f.isSubordinate&&!f.relations[0].pending?d.notifications.add({title:'Subordinate relations can\'t be removed',message:'Subordinate relations can\'t be removed',level:'error'}):relationUtils.destroyRelations(c.db,c.env,[e]),document.dispatchEvent(new Event('topo.clearState'))}inspectRelationClick(a,b){const c=b.topo,d=this.getAttribute('data-endpoint'),e=d.split(':')[0].trim();c.state.changeState({gui:{inspector:{id:e}}})}}module.exports=RelationModule;