'use strict';const proxyquire=require('proxyquire'),utils=require('../../../test/utils'),locateRelativePointOnCanvas=sinon.stub(),RelationModule=proxyquire('./relation',{"./utils":{locateRelativePointOnCanvas:locateRelativePointOnCanvas}});describe('topology relation module',function(){var a,b,c,d,e;beforeAll(function(a){YUI(GlobalConfig).use(['juju-models'],function(b){e=b.namespace('juju.models'),a()})}),beforeEach(function(){a=[],c=utils.makeContainer(this),b=new RelationModule}),afterEach(function(){a.forEach((a)=>a()),a=null,d&&d.unbind()}),it('fires a "clearState" event if a drag line is clicked',function(a){let c=!1;const d=()=>{document.removeEventListener('topo.clearState',d),c=!0,a()};document.addEventListener('topo.clearState',d),b.draglineClicked(void 0,b),assert.equal(c,!0)}),it('has a list of relations',function(){assert.deepEqual(b.relations,[])}),it('has a chainable render function',function(){assert.equal(b.render(),b)}),it('has a rerender method which removes and updates relations',function(){var c=sinon.stub();b.topo={vis:{selectAll:function(){return{remove:c}}}};var d=sinon.stub(b,'update');a.push(d.restore),b.rerender(),assert.equal(c.calledOnce,!0,'Remove was not called'),assert.equal(d.calledOnce,!0,'Update was not called')}),it('fires "changeState" topo event for clicking a relation endpoint',function(){const a={changeState:sinon.stub()};b.topo={state:a};const c=document.createElement('div');c.setAttribute('data-endpoint','one:two'),b.inspectRelationClick.call(c,void 0,b),assert.equal(a.changeState.callCount,1),assert.deepEqual(a.changeState.args[0][0],{gui:{inspector:{id:'one'}}})}),describe('updateRelationVisibility',function(){it('is called on update',function(){var c=sinon.stub(b,'updateRelationVisibility');a.push(c.restore);var d=sinon.stub(b,'decorateRelations');a.push(d.restore);var e=sinon.stub(b,'updateLinks');a.push(e.restore);var f=sinon.stub(b,'updateSubordinateRelationsCount');a.push(f.restore),b.topo={db:{relations:{toArray:function(){}}}},b.update.call(b),assert.equal(c.callCount,1)}),it('categorizes and calls the appropriate vis method',function(){var c=sinon.stub(b,'fade'),d=sinon.stub(b,'hide'),f=sinon.stub(b,'show');a.concat([c.restore,d.restore,f.restore]);var g=new e.ServiceList;g.add([{id:'foo1',fade:!0},{id:'foo2',hide:!0},{id:'foo3'},{id:'foo4',fade:!0,hide:!0}]),b.topo={db:{services:g}},b.updateRelationVisibility(),assert.equal(c.callCount,1),assert.equal(d.callCount,1),assert.equal(f.callCount,1),assert.deepEqual(c.lastCall.args[0],{serviceNames:['foo1','foo4']}),assert.deepEqual(d.lastCall.args[0],{serviceNames:['foo2','foo4']}),assert.deepEqual(f.lastCall.args[0],{serviceNames:['foo3']})})}),describe('ambiguousAddRelationCheck',function(){function d(){f=sinon.stub(b,'addRelationEnd'),a.push(f.restore),g=sinon.stub(b,'_getServiceDisplayName'),a.push(g.restore),h=sinon.stub(b,'_renderAmbiguousRelationMenu'),a.push(h.restore),i=sinon.stub(b,'_attachAmbiguousReleationSelect'),a.push(i.restore),j=sinon.stub(b,'_positionAmbiguousRelationMenu'),a.push(j.restore)}var f,g,h,i,j;it('calls addRelationEnd if relation is not ambiguous',function(){d(this),b.addRelationStart_possibleEndpoints={mysql:[[{name:'db',service:'wordpress',type:'mysql'},{name:'db',service:'mysql',type:'mysql'}]]},b.ambiguousAddRelationCheck({id:'mysql'},b),assert.equal(f.callCount,1),assert.equal(g.callCount,0),assert.equal(h.callCount,0),assert.equal(i.callCount,0),assert.equal(j.callCount,0)}),it('calls the util methods to show ambiguous select menu',function(){d(this),b.addRelationStart_possibleEndpoints={postgresql:[[{service:'python-django',name:'pgsql',type:'pgsql'},{service:'postgresql',name:'db-admin',type:'pgsql'}],[{service:'python-django',name:'pgsql',type:'pgsql'},{service:'postgresql',name:'db',type:'pgsql'}],[{service:'python-django',name:'django-settings',type:'directory-path'},{service:'postgresql',name:'persistent-storage',type:'directory-path'}]]},b.ambiguousAddRelationCheck({id:'postgresql'},b),assert.equal(f.callCount,0),assert.equal(g.callCount,1),assert.equal(h.callCount,1),assert.equal(i.callCount,1),assert.equal(j.callCount,1),assert.deepEqual(g.lastCall.args[0],[[{service:'python-django',name:'pgsql',type:'pgsql'},{service:'postgresql',name:'db-admin',type:'pgsql'}],[{service:'python-django',name:'pgsql',type:'pgsql'},{service:'postgresql',name:'db',type:'pgsql'}],[{service:'python-django',name:'django-settings',type:'directory-path'},{service:'postgresql',name:'persistent-storage',type:'directory-path'}]])}),it('shows correct name for ghost and deployed services',function(){var a=new e.Database({getECS:sinon.stub().returns({changeSet:{}})});a.services.add({id:'97813654$',displayName:'(wordpress)'}),a.services.add({id:'mysql',displayName:'mysql'});var c=b._getServiceDisplayName([[{name:'db',service:'97813654$',type:'mysql'},{name:'db',service:'mysql',type:'mysql'}]],{db:a});assert.deepEqual(c,[[{name:'db',service:'97813654$',type:'mysql',displayName:'wordpress'},{name:'db',service:'mysql',type:'mysql',displayName:'mysql'}]])}),it('renders the ambiguous relation menu',function(){const a=document.createElement('div');a.setAttribute('id','ambiguous-relation-menu');const d=document.createElement('div');d.setAttribute('id','ambiguous-relation-menu-content'),a.appendChild(d),c.appendChild(a);var e=b._renderAmbiguousRelationMenu.call({getContainer:sinon.stub().returns(c)},[[{name:'db',service:'97813654$',type:'mysql',displayName:'wordpress'},{name:'db',service:'mysql',type:'mysql',displayName:'mysql'}],[{name:'db',service:'97813654$',type:'mysql',displayName:'wordpress'},{name:'db',service:'mysql',type:'mysql',displayName:'mysql'}]]);assert.isNotNull(e.querySelector('.menu')),assert.equal(e.querySelectorAll('li').length,2)}),it('attaches the click events for the menu',function(){const a=sinon.stub(),c={querySelector:sinon.stub().returns({addEventListener:a}),querySelectorAll:sinon.stub().returns([{addEventListener:a}])};b._attachAmbiguousReleationSelect(c),assert.equal(a.callCount,2)}),it('calls to position the menu to the terminating endpoint',function(){var a=sinon.stub(),c={style:{},classList:{add:a}},d={zoom:{translate:sinon.stub().returns('translate'),scale:sinon.stub().returns('scale')},active_service:null,active_context:null},e=locateRelativePointOnCanvas.returns(['locate1','locate2']);b._positionAmbiguousRelationMenu(c,d,'m','context'),assert.equal(e.callCount,1,'locateRelativePointOnCanvas'),assert.deepEqual(e.lastCall.args,['m','translate','scale']),assert.deepEqual(c.style,{left:'locate1px',top:'locate2px'}),assert.equal(a.callCount,1,'addClass'),assert.equal(a.lastCall.args[0],'active'),assert.equal(d.active_service,'m'),assert.equal(d.active_context,'context')})})});