'use strict';chai.config.includeStack=!0,chai.config.truncateThreshold=0,describe('jujulib Stripe service',function(){let a;beforeEach(function(){a={createToken:sinon.stub()}}),it('exists',function(){const a=new window.jujulib.stripe('http://example.com','key123');assert.strictEqual(a instanceof window.jujulib.stripe,!0),assert.equal(a.url,'http://example.com/v3/'),assert.equal(a.stripeKey,'key123')}),it('can load the Stripe JavaScript',function(){const b=new window.jujulib.stripe('http://example.com','key123');b._getStripeModule=sinon.stub().returns(sinon.stub().returns(a)),b._getStripe(sinon.stub()),assert.equal(document.querySelector('script').src,'http://example.com/v3/')}),it('calls the callback once the script has loaded',function(){const b=new window.jujulib.stripe('http://example.com','key123'),c=sinon.stub().returns(a);b._loadScript=sinon.stub().callsArg(0),b._getStripeModule=sinon.stub().returns(c);const d=sinon.stub();b._getStripe(d),assert.equal(d.callCount,1),assert.equal(d.args[0][0],a),assert.equal(b._getStripeModule.callCount,1),assert.equal(c.callCount,1),assert.equal(c.args[0][0],'key123')}),it('does not load the script more than once',function(){const b=new window.jujulib.stripe('http://example.com','key123');b._loadScript=sinon.stub().callsArg(0),b._getStripeModule=sinon.stub().returns(sinon.stub().returns(a));const c=sinon.stub();b._getStripe(c),b._getStripe(c),assert.equal(b._loadScript.callCount,1),assert.equal(c.callCount,2)}),describe('createToken',function(){let b,c;beforeEach(function(){b={name:'Mr G Spinach',addressLine1:'1 Maple St',addressLine2:'Right of Nowhere',addressCity:'Somewhere',addressState:'Left a bit',addressZip:'70130',addressCountry:'North of the border'},c={token:{id:'tok_8DPg4qjJ20F1aM',card:{name:null,address_line1:'12 Main Street',address_line2:'Apt 42',address_city:'Palo Alto',address_state:'CA',address_zip:'94301',address_country:'US',country:'US',exp_month:2,exp_year:2018,last4:'4242',object:'card',brand:'Visa',funding:'credit'},created:1490567830,livemode:!0,type:'card',object:'token',used:!1}}}),it('can create a token',function(){a.createToken=sinon.stub().returns({then:sinon.stub().callsArgWith(0,c)});const d=new window.jujulib.stripe('http://example.com/');d.stripe=a,d.createToken({card:'data'},b,sinon.stub()),assert.equal(a.createToken.callCount,1),assert.deepEqual(a.createToken.args[0][0],{card:'data'}),assert.deepEqual(a.createToken.args[0][1],{name:'Mr G Spinach',address_line1:'1 Maple St',address_line2:'Right of Nowhere',address_city:'Somewhere',address_state:'Left a bit',address_zip:'70130',address_country:'North of the border'})}),it('can return the token data',function(){a.createToken=sinon.stub().returns({then:sinon.stub().callsArgWith(0,c)});const d=new window.jujulib.stripe('http://example.com/');d.stripe=a;const e=sinon.stub();d.createToken({},b,e),assert.equal(e.callCount,1),assert.isNull(e.args[0][0]),assert.deepEqual(e.args[0][1],{id:'tok_8DPg4qjJ20F1aM',card:{name:null,addressLine1:'12 Main Street',addressLine2:'Apt 42',addressCity:'Palo Alto',addressState:'CA',addressZip:'94301',addressCountry:'US',country:'US',expMonth:2,expYear:2018,last4:'4242',object:'card',brand:'Visa',funding:'credit'},created:1490567830,livemode:!0,type:'card',object:'token',used:!1})}),it('handles errors when getting a user',function(){a.createToken=sinon.stub().returns({then:sinon.stub().callsArgWith(0,{error:{type:'card_error',code:'invalid_expiry_year',message:'Your card\'s expiration year is invalid.',param:'exp_year'}})});const c=new window.jujulib.stripe('http://example.com/');c.stripe=a;const d=sinon.stub();c.createToken({},b,d),assert.equal(d.callCount,1),assert.equal(d.args[0][0],'Your card\'s expiration year is invalid.'),assert.isNull(d.args[0][1])})}),describe('createCardElement',function(){it('can create a card element',function(){const b=sinon.stub(),c=sinon.stub().returns({created:'created'});a.elements=sinon.stub().returns({create:c});const d=new window.jujulib.stripe('http://example.com/');d.stripe=a,d.createCardElement(b),assert.equal(c.callCount,1),assert.equal(b.callCount,1),assert.deepEqual(b.args[0][0],{created:'created'})})})});