'use strict';chai.config.includeStack=!0,chai.config.truncateThreshold=0,describe('jujulib terms service',function(){let a=[];const b=function(a){return{target:{responseText:JSON.stringify(a)}}};afterEach(function(){a.forEach((a)=>{a()})}),it('exists',function(){const a=new window.jujulib.terms('http://1.2.3.4/',{});assert.strictEqual(a instanceof window.jujulib.terms,!0),assert.strictEqual(a.url,'http://1.2.3.4/'+window.jujulib.termsAPIVersion)}),it('is smart enough to handle missing trailing slash in URL',function(){const a=new window.jujulib.terms('http://1.2.3.4',{});assert.strictEqual(a.url,'http://1.2.3.4/'+window.jujulib.termsAPIVersion)}),it('shows terms with revision',function(a){const c=new window.jujulib.terms('http://1.2.3.4/',{get:function(a,c,d){assert.equal(a,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/terms/canonical?revision=42');const e=b([{name:'canonical',owner:'spinach',title:'canonical terms',revision:42,"created-on":'2016-06-09T22:07:24Z',content:'Terms and conditions'}]);d(null,e)}});c.showTerms('canonical',42,function(b,c){assert.strictEqual(b,null),assert.deepEqual(c,{name:'canonical',owner:'spinach',title:'canonical terms',revision:42,createdAt:new Date(1465510044000),content:'Terms and conditions'}),a()})}),it('shows most recent terms',function(a){const c=new window.jujulib.terms('http://1.2.3.4/',{get:function(a,c,d){assert.equal(a,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/terms/canonical');const e=b([{name:'canonical',owner:'spinach',title:'canonical recent terms',revision:47,"created-on":'2016-06-09T22:07:24Z',content:'Terms and conditions'}]);d(null,e)}});c.showTerms('canonical',null,function(b,c){assert.strictEqual(b,null),assert.deepEqual(c,{name:'canonical',owner:'spinach',title:'canonical recent terms',revision:47,createdAt:new Date(1465510044000),content:'Terms and conditions'}),a()})}),it('handles missing terms',function(a){const c=new window.jujulib.terms('http://1.2.3.4/',{get:function(a,c,d){const e=b([]);d(null,e)}});c.showTerms('canonical',null,function(b,c){assert.strictEqual(b,null),assert.strictEqual(c,null),a()})}),it('handles errors fetching terms',function(a){const c=new window.jujulib.terms('http://1.2.3.4/',{get:function(a,c,d){const e=b({error:'bad wolf'});d(null,e)}});c.showTerms('canonical',null,function(b,c){assert.equal(b,'bad wolf'),assert.strictEqual(c,null),a()})}),it('handles adding an agreement',function(a){const c=new window.jujulib.terms('http://1.2.3.4/',{post:function(a,c,d,e){assert.equal(a,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreement');const f=b({agreements:[{user:'spinach',term:'these-terms',revision:42,"created-on":'2016-06-09T22:07:24Z'}]});e(null,f)}});c.addAgreement([{name:'canonical',revision:5}],function(b,c){assert.equal(b,null),assert.deepEqual(c,[{owner:null,user:'spinach',term:'these-terms',revision:42,createdAt:new Date(1465510044000),name:void 0,owner:void 0,content:void 0}]),a()})}),it('passes the agreements request the correct args',function(){const a={post:sinon.stub()},b=new window.jujulib.terms('http://1.2.3.4/',a);b.addAgreement([{name:'canonical',owner:'spinach',revision:5}]),assert.equal(a.post.callCount,1),assert.equal(a.post.args[0][2],'[{"termname":"canonical","termrevision":5,"termowner":"spinach"}]')}),it('can get agreements for a user',function(a){const c=new window.jujulib.terms('http://1.2.3.4/',{get:function(a,c,d){assert.equal(a,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreements');const e=b([{user:'spinach',term:'One fancy term',revision:47,"created-on":'2016-06-09T22:07:24Z'}]);d(null,e)}});c.getAgreements(function(b,c){assert.strictEqual(b,null),assert.deepEqual(c,[{owner:void 0,user:'spinach',term:'One fancy term',revision:47,createdAt:new Date(1465510044000),name:void 0,owner:void 0,content:void 0}]),a()})}),it('handles missing agreements',function(a){const c=new window.jujulib.terms('http://1.2.3.4/',{get:function(a,c,d){var e=b([]);d(null,e)}});c.getAgreements(function(b,c){assert.strictEqual(b,null),assert.strictEqual(c,null),a()})}),it('handles errors fetching agreements',function(a){const c=new window.jujulib.terms('http://1.2.3.4/',{get:function(a,c,d){const e=b({Message:'bad wolf'});d(null,e)}});c.getAgreements(function(b,c){assert.equal(b,'bad wolf'),assert.strictEqual(c,null),a()})}),describe('getAgreementsByTerms',()=>{it('makes a proper request with a single term supplied',(a)=>{const c=new window.jujulib.terms('http://1.2.3.4/',{get:(a,c,d)=>{assert.equal(a,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreement?Terms=hatch/test-term1'),d(null,b([{"created-on":'2016-06-09T22:07:24Z',content:'I am term1\n',id:'hatch/test-term1',name:'test-term1',owner:'hatch',published:!0,revision:2}]))}});c.getAgreementsByTerms(['hatch/test-term1'],(b,c)=>{assert.strictEqual(b,null),assert.deepEqual(c,[{content:'I am term1\n',createdAt:new Date(1465510044000),name:'test-term1',owner:'hatch',revision:2,term:void 0,user:void 0}]),a()})}),it('makes a proper request with multiple terms supplied',(a)=>{const c=new window.jujulib.terms('http://1.2.3.4/',{get:(a,c,d)=>{assert.equal(a,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreement?Terms=hatch/test-term1&Terms=hatch/test-term2'),d(null,b([{"created-on":'2016-06-09T22:07:24Z',content:'I am term1\n',name:'test-term1',owner:'hatch',published:!0,revision:2}]))}});c.getAgreementsByTerms(['hatch/test-term1','hatch/test-term2'],(b,c)=>{assert.strictEqual(b,null),assert.deepEqual(c,[{content:'I am term1\n',createdAt:new Date(1465510044000),name:'test-term1',owner:'hatch',revision:2,term:void 0,user:void 0}]),a()})}),it('handles failures fetching agreements',(a)=>{const c=new window.jujulib.terms('http://1.2.3.4/',{get:(a,c,d)=>{d(null,b({Message:'it broke'}))}});c.getAgreementsByTerms(['user/termname'],(b,c)=>{assert.equal(b,'it broke'),assert.strictEqual(c,null),a()})})})});